"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppBasePage = void 0;
var react_1 = __importStar(require("react"));
var head_1 = __importDefault(require("./head"));
var loader_1 = __importDefault(require("./loader"));
var error_1 = __importDefault(require("./error"));
var util_1 = require("./util");
var use_current_context_1 = require("../context/use-current-context");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var AppBasePage = function (props) {
    var _a, _b, _c;
    var solution = props.solution, onContextReady = props.onContextReady, appTrack = props.appTrack, libTrack = props.libTrack, allowGuest = props.allowGuest;
    var children = props.children, headProps = props.headProps;
    var currentContextSettings = props.currentContextSettings
        ? props.currentContextSettings
        : {
            signInUrl: "/auth/sign-in"
        };
    var context = (0, use_current_context_1.useCurrentContext)(solution, __assign(__assign({}, currentContextSettings), { signInUrl: !allowGuest ? currentContextSettings.signInUrl : "", componentName: "/page/app-base.tsx" }));
    var pageError = (0, util_1.checkPageError)(props);
    (0, react_1.useEffect)(function () {
        (0, solution_1.setSolution)(solution);
        if (!(0, lodash_1.isEmpty)(context) || allowGuest) {
            onContextReady(context);
        }
        (0, core_1.setAppTrack)(appTrack == true);
        (0, core_1.setLibTrack)(libTrack == true);
    }, [context]);
    return !pageError ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(head_1.default, __assign({}, headProps)),
        !(0, core_1.isSSR)() && (((_a = context.user) === null || _a === void 0 ? void 0 : _a.id) || allowGuest) ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: "h-screen w-full overflow-hidden flex flex-row 2xl:max-w-8xl 2xl:mx-auto ".concat((_b = props.wrapperClassname) !== null && _b !== void 0 ? _b : ""), style: (_c = props.wrapperStyle) !== null && _c !== void 0 ? _c : {} }, children))) : (react_1.default.createElement(loader_1.default, { solution: solution })))) : (react_1.default.createElement(error_1.default, { reason: pageError }));
};
exports.AppBasePage = AppBasePage;
exports.default = exports.AppBasePage;
//# sourceMappingURL=app-base.js.map