"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteBasePage = void 0;
var react_1 = __importStar(require("react"));
var head_1 = __importDefault(require("../page/head"));
var error_1 = __importDefault(require("./error"));
var util_1 = require("./util");
var site_header_1 = __importDefault(require("../sections/site-header"));
var site_footer_1 = __importDefault(require("../sections/site-footer"));
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
// import { ARTICLE_CSS } from "primeobjects-ui-web-basic/build/cjs/css/article-css";
// import CSS from "primeobjects-ui-web-store/build/cjs/css";
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var util_2 = require("../util");
var PageHeadGlobal = undefined;
var HeaderSectionGlobal = undefined;
var FooterSectionGlobal = undefined;
var SiteBasePage = function (props) {
    var _a, _b, _c, _d;
    if (!PageHeadGlobal) {
        console.log("Get global components in /page/site-base.tsx");
        PageHeadGlobal = (0, util_2.getGlobalComponent)("PageHead", head_1.default);
        HeaderSectionGlobal = (0, util_2.getGlobalComponent)("HeaderSection", site_header_1.default);
        FooterSectionGlobal = (0, util_2.getGlobalComponent)("FooterSection", site_footer_1.default);
    }
    var solution = props.solution, footerClassName = props.footerClassName, footerStyle = props.footerStyle, 
    // currentContextSettings,
    appTrack = props.appTrack, libTrack = props.libTrack;
    var site = solution === null || solution === void 0 ? void 0 : solution.site;
    // const context = useCurrentContext(solution, {
    //     ...currentContextSettings,
    //     componentName: "/page/site-base.tsx"
    // });
    var PageHead = (_a = props.Head) !== null && _a !== void 0 ? _a : PageHeadGlobal;
    var HeaderSection = (_b = props.HeaderSection) !== null && _b !== void 0 ? _b : HeaderSectionGlobal;
    var FooterSection = (_c = props.FooterSection) !== null && _c !== void 0 ? _c : FooterSectionGlobal;
    var SSR = (0, core_1.isSSR)();
    (0, react_1.useEffect)(function () {
        if (!SSR)
            (0, solution_1.setSolution)(solution);
        (0, core_1.setAppTrack)(appTrack == true);
        (0, primeobjects_helper_util_1.setLibTrack)(libTrack == true);
    }, [solution.id]);
    //For now we only show navigation to sign in user
    var navigation = (_d = props.navigation) !== null && _d !== void 0 ? _d : site === null || site === void 0 ? void 0 : site.navigation;
    var breadcrumbItems = props.breadcrumbItems, children = props.children, headProps = props.headProps, siteName = props.siteName, siteLogo = props.siteLogo, siteOrgName = props.siteOrgName, SiteLogo = props.SiteLogo;
    var pageError = (0, util_1.checkPageError)(props);
    return !pageError ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(PageHead, __assign({}, headProps)),
        react_1.default.createElement(HeaderSection, { Logo: SiteLogo, solution: solution, navigation: navigation, className: "mb-0 sm:mb-0 md:mb-0 lg:mb-0", pages: breadcrumbItems, siteName: siteName, siteLogo: siteLogo }),
        react_1.default.createElement("div", { className: "min-w-full" }, children),
        react_1.default.createElement(FooterSection, { solution: solution, content: siteName ? siteName : site.title, copyright: site.copyright, businessName: siteOrgName ? siteOrgName : site.businessName, className: footerClassName, style: footerStyle }))) : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(error_1.default, { reason: pageError })));
};
exports.SiteBasePage = SiteBasePage;
exports.default = exports.SiteBasePage;
//# sourceMappingURL=site-base.js.map