import React from "react";
import { TListSectionProps, TOnClickRecordResult } from "../sections/list/index";
import { TListNavOption } from "../sections/list/nav";
import { TFormWrapperProps } from "../components/forms/types";
export type TListPageView = "full-list" | "tree-list" | "list-form" | "dashboard";
export type TListPageProps = {
    view: TListPageView;
    Form: any;
    formViewMaxWidth?: number | string;
    listViewMaxWidth?: number;
    listSectionProps?: TListSectionProps;
    formWrapperProps?: TFormWrapperProps;
    navOptions?: TListNavOption[];
    entity: Record<string, any>;
    currentRecord?: Record<string, any>;
    children?: any;
    adjHeight?: number;
    apis?: Record<string, any>;
    defaultRecordId?: string;
    selectListView?: TListPageView[];
    hideListInfoHeader?: boolean;
    listInfoHeaderContent?: any;
    hideListInfoFooter?: boolean;
    listInfoFooterContent?: any;
    onClickRecord?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => TOnClickRecordResult[] | undefined;
    onResizeWrapper?: (width: number, listPageProps?: TListPageProps) => void;
};
export declare const ListPage: ((props: TListPageProps) => React.JSX.Element) & {
    displayName: string;
};
export default ListPage;
