"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListHeaderSection = void 0;
var react_1 = __importStar(require("react"));
var search_1 = __importDefault(require("../search"));
var auth_call_api_1 = require("../../context/auth-call-api");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var mobx_react_lite_1 = require("mobx-react-lite");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var in_progress_1 = require("../../controls/in-progress");
var action_button_1 = __importDefault(require("../../controls/action-button"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var dropdown_1 = __importDefault(require("../../controls/antd/dropdown"));
var menu_1 = __importDefault(require("../../controls/antd/menu"));
var popover_1 = __importDefault(require("../../controls/antd/popover"));
var plainjs_1 = require("@json2csv/plainjs");
var lodash_1 = require("lodash");
var local_storage_1 = require("primeobjects-ui-web-basic/build/cjs/util/local-storage");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var util_1 = require("../../util");
var csvtojson_1 = __importDefault(require("csvtojson"));
var UploadField = null;
var PicklistField = null;
exports.ListHeaderSection = (0, mobx_react_lite_1.observer)(function (props) {
    var _a, _b;
    if (!UploadField) {
        console.log("Get global components in /sections/list/header.tsx");
        UploadField = (0, util_1.getGlobalComponent)("UploadField");
        PicklistField = (0, util_1.getGlobalComponent)("PicklistField");
    }
    var entity = props.entity, cancelSearch = props.cancelSearch, showTags = props.showTags, hideSearchService = props.hideSearchService, queryResult = props.queryResult, apis = props.apis;
    var envStore = (0, primeobjects_ui_web_store_1.useEnvStore)();
    var envData = JSON.parse(envStore.data);
    var searching = (_a = envData === null || envData === void 0 ? void 0 : envData.search) === null || _a === void 0 ? void 0 : _a.doing;
    var primaryColor = (0, primeobjects_helper_ui_1.usePrimaryColor)();
    var solution = (0, solution_1.useSolution)();
    var createButtonText = props.createButtonText
        ? props.createButtonText
        : props.showBatchButton
            ? "Create"
            : "New";
    var _c = (0, react_1.useState)(undefined), searchService = _c[0], setSearchService = _c[1];
    var hideCreateButton = entity.disableCreate == true ||
        props.hideCreateButton == true ||
        !props.onClickCreateButton;
    var exportProps = (_b = props.exportProps) !== null && _b !== void 0 ? _b : [
        "id|string|ID",
        "display|string|Display",
        "stateCode|int|State Code",
        "statusCode|int|Status Code",
        "createdOn|datetime|Created On",
        "modifiedOn|datetime|Modified On",
        "organizationId|string|Organization ID",
        "solutionId|string|Solution ID"
    ];
    var _d = (0, react_1.useState)(false), openCategories = _d[0], setOpenCategories = _d[1];
    var _e = (0, react_1.useState)(false), openUpload = _e[0], setOpenUpload = _e[1];
    var _f = (0, react_1.useState)(undefined), uploadInfo = _f[0], setUploadInfo = _f[1];
    var _g = (0, react_1.useState)(false), openBatch = _g[0], setOpenBatch = _g[1];
    var _h = (0, react_1.useState)(20), batchSize = _h[0], setBatchSize = _h[1];
    var _j = (0, react_1.useState)(undefined), batchInfo = _j[0], setBatchInfo = _j[1];
    var exportResult = (0, react_1.useRef)({
        count: 0,
        data: []
    });
    var exportQuery = (0, react_1.useRef)(undefined);
    var _k = (0, react_1.useState)(-1), exportCount = _k[0], setExportCount = _k[1];
    var abortController = (0, react_1.useRef)();
    var isExporting = exportCount >= 0;
    var query = queryResult === null || queryResult === void 0 ? void 0 : queryResult.query;
    var result = queryResult === null || queryResult === void 0 ? void 0 : queryResult.result;
    (0, react_1.useEffect)(function () {
        //check whether there is a local saved search service
        var localQueryService = (0, local_storage_1.getLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName));
        setSearchService(hideSearchService
            ? "hidden"
            : (query === null || query === void 0 ? void 0 : query.service) != "hidden" && localQueryService
                ? localQueryService
                : (query === null || query === void 0 ? void 0 : query.service)
                    ? query === null || query === void 0 ? void 0 : query.service
                    : "auto");
    }, [query]);
    var onSubmitSearch = function (keywords) {
        props.onSubmitSearch && props.onSubmitSearch(keywords);
    };
    var onRefresh = function () {
        props.onRefresh && props.onRefresh();
    };
    var getPropValue = function (record, name) {
        if (!name || !(0, primeobjects_helper_util_1.isNonEmptyString)(name) || !record)
            return undefined;
        var layers = name.split(".");
        if (layers.length > 1) {
            var curName = layers.shift();
            if (curName) {
                var newRecord = record[curName];
                var newName = layers.join(".");
                return getPropValue(newRecord, newName);
            }
            else {
                return undefined;
            }
        }
        return record[name];
    };
    var onClickExport = function (all) {
        all ? onClickExportAll() : onClickExportCurrent();
    };
    var onClickExportAll = function () {
        try {
            if (query) {
                exportQuery.current = (0, lodash_1.cloneDeep)(query);
                exportQuery.current.name = "first";
                exportQuery.current.attributes = (0, lodash_1.uniq)((0, lodash_1.map)(exportProps, function (p) {
                    return p.split("|")[0].split(".")[0];
                })).join(",");
                exportQuery.current.pageNumber = 1;
                exportQuery.current.pageSize = 50;
                queryExportAll(0);
            }
        }
        catch (err) {
            console.error(err);
        }
    };
    var queryExportAll = function (count) {
        var _a;
        var apiEndpoint = apis
            ? (0, util_1.getApiEndpointBase)(apis, "data", "query")
            : (0, util_1.getApiEndpoint)(solution, "data", "query", entity === null || entity === void 0 ? void 0 : entity.entityName);
        if (apiEndpoint) {
            (_a = abortController.current) === null || _a === void 0 ? void 0 : _a.abort();
            abortController.current = new AbortController();
            setExportCount(count);
            (0, auth_call_api_1.callApi)(solution, apiEndpoint, { query: exportQuery.current }, "post", {
                abortSignal: abortController.current.signal
            })
                .then(function (r) {
                var _a, _b;
                var newResult = { count: 0, data: [] };
                switch ((_a = exportQuery.current) === null || _a === void 0 ? void 0 : _a.name) {
                    case "more": {
                        newResult = {
                            count: exportResult.current.count + r.count,
                            continuation: r.continuation,
                            data: __spreadArray(__spreadArray([], exportResult.current.data, true), r.data, true)
                        };
                        break;
                    }
                    default: {
                        newResult = r;
                        break;
                    }
                }
                exportResult.current = newResult;
                if ((0, lodash_1.isNumber)(newResult.continuation) &&
                    ((_b = exportQuery.current) === null || _b === void 0 ? void 0 : _b.pageNumber)) {
                    exportQuery.current.name = "more";
                    exportQuery.current.pageNumber =
                        exportQuery.current.pageNumber + 1;
                    queryExportAll(newResult.count);
                }
                else {
                    setExportCount(-1);
                    exportData(newResult);
                }
            })
                .catch(function (ex) {
                console.error(ex);
                alert("Sorry, the export failed, please try again later.");
                setExportCount(-1);
                abortController.current = null;
            });
        }
    };
    var onClickExportCurrent = function () {
        exportData(result);
    };
    var exportData = function (result) {
        try {
            if (result) {
                var parser = new plainjs_1.Parser();
                var data = (0, lodash_1.map)(result === null || result === void 0 ? void 0 : result.data, function (r) {
                    var newR = {};
                    (0, lodash_1.each)(exportProps, function (fname) {
                        var nameType = fname.split("|");
                        var type = nameType.length > 1 ? nameType[1] : "";
                        var name = nameType[0];
                        var label = nameType.length > 2 ? nameType[2] : name;
                        var value = getPropValue(r, name);
                        var typeDef = type.split(".");
                        type = typeDef[0];
                        var decimal = typeDef.length > 1
                            ? parseInt(typeDef[1])
                            : undefined;
                        switch (type) {
                            case "datetime": {
                                newR[label] = !(0, lodash_1.isNil)(value)
                                    ? new Date(value)
                                    : "";
                                break;
                            }
                            case "int": {
                                newR[label] = !(0, lodash_1.isNil)(value)
                                    ? parseInt(value)
                                    : "";
                                break;
                            }
                            case "percent": {
                                newR[label] = !(0, lodash_1.isNil)(value)
                                    ? parseFloat(value).toFixed(decimal !== null && decimal !== void 0 ? decimal : 2)
                                    : "";
                                break;
                            }
                            case "money": {
                                newR[label] = !(0, lodash_1.isNil)(value)
                                    ? parseFloat(value).toFixed(decimal !== null && decimal !== void 0 ? decimal : 2)
                                    : "";
                                break;
                            }
                            case "number":
                            case "float": {
                                newR[label] = !(0, lodash_1.isNil)(value)
                                    ? decimal
                                        ? parseFloat(value).toFixed(decimal)
                                        : parseFloat(value)
                                    : "";
                                break;
                            }
                            default: {
                                newR[label] = !(0, lodash_1.isNil)(value) ? value : "";
                                break;
                            }
                        }
                        // if (
                        //     isNumber(v) &&
                        //     isDate(new Date(v)) &&
                        //     new Date(v).getTime() -
                        //         new Date("1971-1-1").getTime() >
                        //         0
                        // ) {
                        //     newR[fname] = new Date(v);
                        // } else {
                        //     newR[fname] = v;
                        // }
                    });
                    return newR;
                });
                var csv = parser.parse(data);
                var element = document.createElement("a");
                element.setAttribute("href", "data:text/plain;charset=utf-8," +
                    encodeURIComponent("".concat(csv)));
                element.setAttribute("download", "".concat(entity.entityName.toLowerCase()).concat(entity.entityType
                    ? "-".concat(entity.entityType.toLowerCase())
                    : "", "-").concat(Date.now(), ".csv"));
                element.style.display = "none";
                document.body.appendChild(element);
                element.click();
                document.body.removeChild(element);
            }
        }
        catch (err) {
            console.error(err);
        }
    };
    var onClickToggleTagsButton = function () {
        props.onClickToggleTagsButton && props.onClickToggleTagsButton();
    };
    var onClickFilterButton = function () { };
    var onClickCreateButton = function () {
        props.onClickCreateButton &&
            props.onClickCreateButton({
                id: (0, primeobjects_helper_util_1.newGuid)(),
                entityName: entity.entityName,
                entityType: entity.entityType
            });
    };
    var onClickSearchService = function (service) {
        (0, local_storage_1.setLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName), service);
        setSearchService(service);
        props.onRefresh && props.onRefresh();
    };
    var renderCurrentSearchServiceName = function () {
        switch (searchService) {
            case "database": {
                return "Simple search engine";
            }
            case "elastic": {
                return "Full-text search engine";
            }
            default: {
                return "Auto search engine";
            }
        }
    };
    var createBatchRecord = function (batchInfo) {
        if (batchInfo) {
            (0, auth_call_api_1.callApi)(solution, (0, util_1.getApiEndpoint)(solution, "data", "create", entity.entityName), {
                data: props.onProcessBatchRecord
                    ? props.onProcessBatchRecord({
                        entityName: entity.entityName,
                        entityType: entity.entityType
                    })
                    : {
                        entityName: entity.entityName,
                        entityType: entity.entityType
                    },
                entity: entity
            }, "POST")
                .then(function (newRecord) {
                props.onBatchRecord && props.onBatchRecord(newRecord);
                var newBatchInfo = __assign(__assign({}, batchInfo), { finished: batchInfo.finished + 1, progress: batchInfo.progress + 1 });
                setBatchInfo(newBatchInfo);
                if (newBatchInfo.total > newBatchInfo.progress) {
                    createBatchRecord(newBatchInfo);
                }
            })
                .catch(function (error) {
                console.error(error);
                var newBatchInfo = __assign(__assign({}, batchInfo), { failed: batchInfo.failed + 1, progress: batchInfo.progress + 1 });
                setBatchInfo(newBatchInfo);
                if (newBatchInfo.total > newBatchInfo.progress) {
                    createBatchRecord(newBatchInfo);
                }
            });
        }
    };
    var createUploadRecord = function (uploadInfo) {
        if (uploadInfo) {
            var data = uploadInfo.records[uploadInfo.progress];
            (0, auth_call_api_1.callApi)(solution, (0, util_1.getApiEndpoint)(solution, "data", "create", entity.entityName), {
                data: props.onProcessUploadRecord
                    ? props.onProcessUploadRecord(__assign(__assign({}, data), { entityName: entity.entityName, entityType: entity.entityType }))
                    : __assign(__assign({}, data), { entityName: entity.entityName, entityType: entity.entityType }),
                entity: entity
            }, "POST")
                .then(function (newRecord) {
                props.onUploadRecord && props.onUploadRecord(newRecord);
                var newUploadInfo = __assign(__assign({}, uploadInfo), { finished: uploadInfo.finished + 1, progress: uploadInfo.progress + 1 });
                setUploadInfo(newUploadInfo);
                if (newUploadInfo.total > newUploadInfo.progress) {
                    createUploadRecord(newUploadInfo);
                }
            })
                .catch(function (error) {
                console.error(error);
                var newUploadInfo = __assign(__assign({}, uploadInfo), { failed: uploadInfo.failed + 1, progress: uploadInfo.progress + 1 });
                setUploadInfo(newUploadInfo);
                if (newUploadInfo.total > newUploadInfo.progress) {
                    createUploadRecord(newUploadInfo);
                }
            });
        }
    };
    var renderUploadUI = function () {
        var allDone = uploadInfo
            ? uploadInfo.total == uploadInfo.progress
            : false;
        return (react_1.default.createElement("div", { className: "w-full p-3" }, uploadInfo ? (react_1.default.createElement("div", { className: "flex flex-col w-full" },
            react_1.default.createElement("div", { className: "flex flex-col items-center text-center" },
                !allDone
                    ? "Creating ".concat(entity.uiCollectionName, " ...")
                    : "The records have been created.",
                react_1.default.createElement("br", null),
                "(",
                uploadInfo.progress,
                "/",
                uploadInfo.total,
                ", Finished:",
                uploadInfo.finished,
                ", Failed:",
                uploadInfo.failed,
                ")"),
            react_1.default.createElement("div", { className: "flex flex-col items-center mt-3" },
                react_1.default.createElement("button", { className: "bg-gray-100 border py-1 px-2", onClick: function () {
                        setOpenUpload(false);
                        setUploadInfo(undefined);
                    } }, allDone ? "Ok" : "Cancel")))) : (react_1.default.createElement(UploadField, { name: "uploadTo".concat(entity.entityName, "List"), accept: ".csv", resultType: "content", onUploaded: function (v, info) {
                (0, primeobjects_helper_util_1.doNothing)(v);
                if (info === null || info === void 0 ? void 0 : info.content) {
                    var content = info.content;
                    (0, csvtojson_1.default)()
                        .fromString(content)
                        .then(function (records) {
                        if (records.length == 0) {
                            alert("There is no record uploaded.");
                        }
                        else {
                            createUploadRecord({
                                failed: 0,
                                finished: 0,
                                progress: 0,
                                records: records,
                                total: records.length
                            });
                        }
                    });
                }
            }, label: "Click the upload button below to upload a .csv file." }))));
    };
    var renderBatchUI = function () {
        var allDone = batchInfo
            ? batchInfo.total == batchInfo.progress
            : false;
        return (react_1.default.createElement("div", { className: "w-full p-3" }, batchInfo ? (react_1.default.createElement("div", { className: "flex flex-col w-full" },
            react_1.default.createElement("div", { className: "flex flex-col items-center text-center" },
                !allDone
                    ? "Creating ".concat(entity.uiCollectionName, " ...")
                    : "The records have been created.",
                react_1.default.createElement("br", null),
                "(",
                batchInfo.progress,
                "/",
                batchInfo.total,
                ", Finished:",
                batchInfo.finished,
                ", Failed:",
                batchInfo.failed,
                ")"),
            react_1.default.createElement("div", { className: "flex flex-col items-center mt-3" },
                react_1.default.createElement("button", { className: "bg-gray-100 border py-1 px-2 rounded-md shadow hover:shadow-lg", onClick: function () {
                        setOpenBatch(false);
                        setBatchInfo(undefined);
                    } }, allDone ? "Ok" : "Cancel")))) : (react_1.default.createElement("div", { className: "w-full flex flex-col" },
            react_1.default.createElement(PicklistField, { name: "bacthCreate".concat(entity.entityName, "List"), label: "Select the size of the batch.", onChange: function (total) {
                    setBatchSize(total);
                }, options: [
                    {
                        value: 10,
                        text: "10"
                    },
                    {
                        value: 20,
                        text: "20"
                    },
                    {
                        value: 30,
                        text: "30"
                    },
                    {
                        value: 40,
                        text: "40"
                    },
                    {
                        value: 50,
                        text: "50"
                    },
                    {
                        value: 75,
                        text: "75"
                    },
                    {
                        value: 100,
                        text: "100"
                    }
                ], defaultValue: 20 }),
            react_1.default.createElement("div", { className: "flex flex-col items-center mt-3" },
                react_1.default.createElement("button", { className: "bg-green-500 hover:bg-green-600 text-white py-1 px-2 rounded-md shadow hover:shadow-lg w-fit", onClick: function () {
                        setBatchInfo({
                            failed: 0,
                            finished: 0,
                            progress: 0,
                            records: new Array(batchSize),
                            total: batchSize
                        });
                        createBatchRecord({
                            failed: 0,
                            finished: 0,
                            progress: 0,
                            records: new Array(batchSize),
                            total: batchSize
                        });
                    } },
                    "Create ",
                    entity.uiCollectionName))))));
    };
    return (react_1.default.createElement("div", { className: "w-full flex flex-row py-4 items-center relative bg-white" },
        !props.hideEntityIcon && (react_1.default.createElement("div", { className: "flex ml-4" },
            react_1.default.createElement(svg_1.default, { src: entity.icon, size: 32, color: primeobjects_helper_util_1.COLORS.GRAY["900"] }))),
        props.onSubmitSearch &&
            !props.hideSearch &&
            (isExporting ? (react_1.default.createElement("div", { className: "w-full p-1" })) : (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(search_1.default, { searching: searching, onSubmit: onSubmitSearch, placeholder: entity.searchInputPlaceholder
                        ? entity.searchInputPlaceholder
                        : "Search ".concat(entity.uiCollectionName, " ..."), wrapperStyle: searchService == "hidden"
                        ? { height: 32 }
                        : { height: 20 }, wrapperClassName: searchService == "hidden" ? "px-2" : "px-2 pt-2", inputClassName: "max-w-xs", cancelSearch: cancelSearch }),
                searchService != "hidden" && (react_1.default.createElement("div", { className: "absolute cursor-pointer", style: { top: 8, left: 56 } },
                    react_1.default.createElement("div", { style: { width: 150 } },
                        react_1.default.createElement(dropdown_1.default, { trigger: ["click"], placement: "top", overlay: react_1.default.createElement(menu_1.default, null,
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("auto");
                                    } }, "Auto search engine"),
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("database");
                                    } }, "Simple search engine"),
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("elastic");
                                    } }, "Full-text search engine")) },
                            react_1.default.createElement("div", { className: "w-full flex" },
                                react_1.default.createElement("div", { className: "text-xs" }, renderCurrentSearchServiceName()),
                                react_1.default.createElement(svg_1.default, { style: { margin: 4 }, src: "/icons/platform/down.svg", size: 10, color: primeobjects_helper_util_1.COLORS.GRAY["900"] }))))))))),
        react_1.default.createElement("div", { className: "flex mr-4" },
            props.hideCategoriesButton != true &&
                !isExporting &&
                props.renderCategories && (react_1.default.createElement(popover_1.default, { placement: "bottomRight", open: openCategories, onOpenChange: function (newOpen) {
                    setOpenCategories(newOpen);
                }, trigger: "click", content: react_1.default.createElement("div", { style: { width: 350 } }, props.renderCategories(function () {
                    setOpenCategories(false);
                })) },
                react_1.default.createElement(action_button_1.default, { id: "list-header-categories", iconSrc: "/icons/platform/categories.svg" }))),
            (exportProps === null || exportProps === void 0 ? void 0 : exportProps.length) > 0 &&
                !props.hideExportButton &&
                (isExporting ? (react_1.default.createElement("div", { className: "min-w-32 flex flex-row" },
                    react_1.default.createElement("div", { className: "min-w-18" },
                        react_1.default.createElement(in_progress_1.InProgress, null)),
                    react_1.default.createElement("div", { className: "leading-none self-center w-full text-sm" }, "Exporting"),
                    exportCount > 0 && (react_1.default.createElement("div", { className: "ml-1 leading-none self-center w-full text-sm" }, exportCount < 1000
                        ? exportCount
                        : (0, primeobjects_helper_util_1.formatNumberBMK)(exportCount))))) : (react_1.default.createElement(dropdown_1.default, { trigger: ["click"], overlay: react_1.default.createElement(menu_1.default, null,
                        react_1.default.createElement(menu_1.default.Item, { key: "export-current", className: "w-full", onClick: function () {
                                onClickExport(false);
                            } },
                            react_1.default.createElement("span", null, "Export current records")),
                        react_1.default.createElement(menu_1.default.Item, { key: "export-all", className: "w-full", onClick: function () {
                                onClickExport(true);
                            } },
                            react_1.default.createElement("span", null, "Export all records"))), placement: "bottomLeft" },
                    react_1.default.createElement(action_button_1.default, { id: "list-header-export-csv", iconSrc: "/icons/platform/export-csv.svg" })))),
            props.showUploadButton && (react_1.default.createElement(popover_1.default, { placement: "bottomRight", open: openUpload, onOpenChange: function (newOpen) {
                    setOpenUpload(newOpen);
                }, trigger: "click", content: react_1.default.createElement("div", { style: { width: 250 } }, renderUploadUI()) },
                react_1.default.createElement(action_button_1.default, { id: "list-header-upload-csv", iconSrc: "/icons/platform/upload-csv.svg" }))),
            props.onRefresh && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-refresh", onClick: onRefresh, iconSrc: "/icons/platform/refresh.svg" })),
            props.onClickToggleTagsButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickToggleTagsButton, iconSrc: "/icons/platform/tags.svg", tooltipText: "Toggle tags", iconColor: showTags ? primaryColor["600"] : undefined })),
            props.onClickFilterButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickFilterButton, iconSrc: "/icons/platform/filter.svg" })),
            props.showBatchButton && (react_1.default.createElement(popover_1.default, { placement: "bottomRight", open: openBatch, onOpenChange: function (newOpen) {
                    setOpenBatch(newOpen);
                }, trigger: "click", content: react_1.default.createElement("div", { style: { width: 250 } }, renderBatchUI()) },
                react_1.default.createElement(action_button_1.default, { id: "list-header-batch", iconSrc: "/icons/platform/batch.svg", wrapperClassName: "bg-green-500 hover:bg-green-600", text: "Batch Create", iconColor: primeobjects_helper_util_1.COLORS.WHITE, textColor: primeobjects_helper_util_1.COLORS.WHITE }))),
            !hideCreateButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-new", onClick: onClickCreateButton, wrapperClassName: "bg-green-500 hover:bg-green-600", text: createButtonText, textColor: primeobjects_helper_util_1.COLORS.WHITE })))));
});
exports.default = exports.ListHeaderSection;
//# sourceMappingURL=header.js.map