"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteHeaderSection = void 0;
var react_1 = __importDefault(require("react"));
var site_navigation_1 = __importDefault(require("./site-navigation"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var env_1 = require("primeobjects-ui-web-store/build/cjs/stores/env");
var mobx_react_lite_1 = require("mobx-react-lite");
var site_breadcrumb_1 = __importDefault(require("./site-breadcrumb"));
exports.SiteHeaderSection = (0, mobx_react_lite_1.observer)(function (props) {
    var navigation = props.navigation, solution = props.solution, onClickLogo = props.onClickLogo, pages = props.pages, siteName = props.siteName, siteLogo = props.siteLogo, Logo = props.Logo;
    var className = (0, core_1.isNonEmptyString)(props.className) ? props.className : "";
    var style = (0, core_1.isObject)(props.style) ? props.style : {};
    var env = (0, env_1.useEnvStore)();
    return (react_1.default.createElement("header", { className: "max-w-7xl py-4 w-full mx-auto px-6 sm:px-8 lg:px-10 sticky top-0 bg-white z-20 ".concat(env.scrollTop > 38 ? "border-b" : "", " ").concat(className), style: style },
        react_1.default.createElement(site_navigation_1.default, { Logo: Logo, solution: solution, navigation: navigation, onClickLogo: onClickLogo, siteName: siteName, siteLogo: siteLogo }),
        pages && pages.length > 1 && (react_1.default.createElement(site_breadcrumb_1.default, { solution: solution, pages: pages }))));
});
exports.default = exports.SiteHeaderSection;
//# sourceMappingURL=site-header.js.map