"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteNavigation = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var logo_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/logo"));
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var react_2 = require("@headlessui/react");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var menu_desktop_1 = require("primeobjects-ui-web-basic/build/cjs/controls/header/menu-desktop");
var menu_mobile_1 = require("primeobjects-ui-web-basic/build/cjs/controls/header/menu-mobile");
var redirect_button_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/redirect-button"));
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var auth_cognito_1 = require("../context/auth-cognito");
var SiteNavigation = function (props) {
    var navigation = props.navigation, solution = props.solution, Logo = props.Logo;
    var style = (0, primeobjects_helper_util_1.isObject)(props.style) ? props.style : {};
    var _a = (0, react_1.useState)(false), hasUserSession = _a[0], setHasUserSession = _a[1];
    var className = (0, primeobjects_helper_util_1.isNonEmptyString)(props.className) ? props.className : "";
    var primaryColor = (0, primary_color_1.usePrimaryColor)(solution);
    var site = solution.site;
    var siteName = props.siteName
        ? props.siteName
        : (site === null || site === void 0 ? void 0 : site.name)
            ? site === null || site === void 0 ? void 0 : site.name
            : "";
    var siteLogo = props.siteLogo
        ? props.siteLogo
        : (site === null || site === void 0 ? void 0 : site.logo)
            ? site === null || site === void 0 ? void 0 : site.logo
            : "/logo.svg";
    (0, react_1.useEffect)(function () {
        (0, auth_cognito_1.getCurrentPoolUser)(solution).then(function (r) {
            setHasUserSession(!(0, lodash_1.isNil)(r));
        });
    }, [solution === null || solution === void 0 ? void 0 : solution.id]);
    var onClickLogo = function () {
        if (props.onClickLogo) {
            return props.onClickLogo();
        }
        else {
            (0, primeobjects_helper_util_1.getWindow)().location.replace("/");
        }
    };
    return (react_1.default.createElement(react_2.Popover, null,
        react_1.default.createElement("div", { className: "relative flex flex-row ".concat(className), style: style },
            react_1.default.createElement("nav", { className: "relative flex flex-row w-full items-center justify-between sm:h-10 lg:justify-start", "aria-label": "Global" }, Logo !== null && Logo !== void 0 ? Logo : (react_1.default.createElement(logo_1.default, { id: "nav-logo", onClick: onClickLogo, logoSrc: siteLogo, logoSize: 30, text: siteName, color: primaryColor["600"] })),
                react_1.default.createElement("div", { className: "hidden md:flex space-x-8 pl-8" }, (0, lodash_1.isArray)(navigation) && navigation.length > 0 && (react_1.default.createElement(menu_desktop_1.HeadMenuDesktopView, { navigation: navigation, color: primaryColor }))),
                (0, lodash_1.isArray)(navigation) && navigation.length > 0 && (react_1.default.createElement("div", { className: "flex items-center flex-grow flex-shrink-0 lg:flex-grow-0" },
                    react_1.default.createElement("div", { className: "flex items-center justify-end w-full md:w-auto " },
                        react_1.default.createElement("div", { className: "-mr-2 flex items-center md:hidden" },
                            react_1.default.createElement(react_2.Popover.Button, { className: "bg-white rounded-md p-2 inline-flex items-center  border justify-center text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none" },
                                react_1.default.createElement("span", { className: "sr-only" }, "Open main menu"),
                                react_1.default.createElement(svg_1.default, { id: "nav-menu", src: "/icons/platform/menu.svg", size: 30 }))))))),
            hasUserSession && (react_1.default.createElement(redirect_button_1.default, { color: primaryColor[400], targetUrl: "/list/dashboard", className: "max-w-28 min-w-28 min-h-10 rounded-md flex flex-col items-center cursor-pointer border p-2 bg-gray-50 font-base text-sm hover:shadow justify-center" }, "Dashboard"))),
        react_1.default.createElement(react_2.Transition, { as: react_1.Fragment, enter: "duration-150 ease-out", enterFrom: "opacity-0 scale-95", enterTo: "opacity-100 scale-100", leave: "duration-100 ease-in", leaveFrom: "opacity-100 scale-100", leaveTo: "opacity-0 scale-95" },
            react_1.default.createElement(react_2.Popover.Panel, { className: "fixed bg-white z-10 top-0 left-0 inset-x-0 p-2 transition transform origin-top-right md:hidden h-full " },
                react_1.default.createElement("div", { className: "rounded-lg shadow-md bg-white ring-1 ring-black ring-opacity-5 h-full overflow-hidden" },
                    react_1.default.createElement("div", { className: "px-5 py-3 flex items-center justify-between h-18 border-b" },
                        react_1.default.createElement(Logo, { id: "nav-pop-lego", color: primaryColor["600"], onClick: onClickLogo, logoSrc: siteLogo, logoSize: 30, text: siteName, textStyle: { color: primaryColor["600"] } }),
                        react_1.default.createElement("div", { className: "-mr-2" },
                            react_1.default.createElement(react_2.Popover.Button, { className: "bg-white rounded-md p-2 inline-flex items-center justify-center text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none" },
                                react_1.default.createElement("span", { className: "sr-only" }, "Close main menu"),
                                react_1.default.createElement(svg_1.default, { id: "nav-pop-close", src: "/icons/platform/close.svg", size: 30 })))),
                    react_1.default.createElement("div", { className: "px-2 pt-2 pb-3 space-y-1 overflow-hidden overflow-y-auto", style: { height: "calc(100% - 66px)" } },
                        react_1.default.createElement(react_2.Popover.Group, { as: "nav", className: "space-x-10" }, (0, lodash_1.isArray)(navigation) &&
                            navigation.length > 0 && (react_1.default.createElement(menu_mobile_1.HeadMenuMobileView, { navigation: navigation })))))))));
};
exports.SiteNavigation = SiteNavigation;
exports.default = exports.SiteNavigation;
//# sourceMappingURL=site-navigation.js.map