"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteSwiperSection = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var site_title_1 = __importDefault(require("./site-title"));
var util_1 = require("../util");
var record_1 = require("primeobjects-helper-util/build/cjs/record");
var slug_1 = require("primeobjects-helper-util/build/cjs/slug");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var lodash_1 = require("lodash");
var util_2 = require("../util");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var content_loader_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/content-loader"));
var navigation_1 = require("next/navigation");
var util_3 = require("../util");
var SwiperComponent = undefined;
var SwiperPagination = undefined;
var SwiperSlide = undefined;
var SiteSwiperSection = function (props) {
    var solution = props.solution, feedValue = props.feedValue, feedType = props.feedType, title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize, pageNumber = props.pageNumber, urlTemplate = props.urlTemplate, globalOrganizationId = props.globalOrganizationId, scope = props.scope, flushCache = props.flushCache;
    if (!SwiperComponent) {
        console.log("Get global components in /sections/site-swiper.tsx");
        SwiperComponent = (0, util_3.getGlobalComponent)("SwiperComponent");
        SwiperPagination = (0, util_3.getGlobalComponent)("SwiperPagination");
        SwiperSlide = (0, util_3.getGlobalComponent)("SwiperSlide");
    }
    var router = (0, navigation_1.useRouter)();
    var _a = (0, react_1.useState)(null), result = _a[0], setResult = _a[1];
    var SSR = (0, core_1.isSSR)();
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var itemTitleClassName = (0, core_1.isNonEmptyString)(props.itemTitleClassName)
        ? props.itemTitleClassName
        : "";
    var entityName = props.entityName ? props.entityName : "Card";
    var pageSize = (0, lodash_1.isNumber)(props.pageSize) && props.pageSize > 0 ? props.pageSize : 5;
    var data = (result === null || result === void 0 ? void 0 : result.data) ? result === null || result === void 0 ? void 0 : result.data : [];
    var primaryColor = (0, primeobjects_helper_ui_1.getPrimaryColor)(solution);
    var id = (0, slug_1.slug)("".concat(title, "-").concat(feedValue, "-").concat(feedType));
    var cacheKey = props.cacheKey
        ? "".concat(props.cacheKey, "-").concat(feedType, "-").concat(feedValue, "-").concat(scope)
        : undefined;
    var getQuery = function () {
        switch (feedType) {
            case "tags":
                return {
                    scope: scope,
                    entityName: entityName,
                    pageSize: pageSize,
                    pageNumber: pageNumber,
                    tags: feedValue.split(","),
                    globalOrganizationId: globalOrganizationId,
                    conditions: [
                        { attribute: "stateCode", op: ">=", value: 0 }
                    ],
                    attributes: "slug,id,media,title,name,abstract,summary"
                };
            case "categories":
                return {
                    scope: scope,
                    entityName: entityName,
                    pageSize: pageSize,
                    pageNumber: pageNumber,
                    categoryIds: feedValue.split(","),
                    globalOrganizationId: globalOrganizationId,
                    conditions: [
                        { attribute: "stateCode", op: ">=", value: 0 }
                    ],
                    attributes: "slug,id,media,title,name,abstract,summary"
                };
        }
    };
    (0, react_1.useEffect)(function () {
        if (solution.id && !SSR) {
            var apiUrl = (0, util_2.getApiEndpoint)(solution, "data", "query");
            (0, util_1.callApiBase)(apiUrl, {
                query: getQuery(),
                cacheKey: cacheKey,
                flushCache: flushCache,
                cacheExpireMinutes: 60 * 24 * 365
            }, "POST", { solutionId: solution.id })
                .then(function (result) {
                setResult(result);
            })
                .catch(function () {
                setResult({ count: 0, data: [] });
            });
        }
    }, [solution.id, SSR]);
    return (0, lodash_1.isNil)(result) || (!(0, lodash_1.isNil)(result) && data.length > 0) ? (react_1.default.createElement("div", { className: "w-full ".concat(wrapperClassName) },
        react_1.default.createElement(site_title_1.default, { title: title, subTitle: subTitle, titleSize: titleSize, subTitleSize: subTitleSize, titleClassName: "text-left text-".concat(primaryColor.name, "-600"), subTitleClassName: "text-left" }),
        react_1.default.createElement("div", { className: "w-full" }, (0, lodash_1.isNil)(result) ? (react_1.default.createElement("div", { className: "w-full h-full mb-16" },
            react_1.default.createElement(content_loader_1.default, { id: id ? id : (0, primeobjects_helper_util_1.newGuid)(), height: 100, count: 5, width: 400, barHeight: 10 }))) : (react_1.default.createElement(SwiperComponent, { slidesPerView: 1, spaceBetween: 10, pagination: {
                clickable: true
            }, breakpoints: {
                640: {
                    slidesPerView: Math.min(data.length, 2),
                    spaceBetween: Math.min(data.length, 2) * 10
                },
                768: {
                    slidesPerView: Math.min(data.length, 3),
                    spaceBetween: Math.min(data.length, 3) * 10
                },
                1024: {
                    slidesPerView: Math.min(data.length, 4),
                    spaceBetween: Math.min(data.length, 4) * 10
                }
            }, modules: [SwiperPagination] }, (0, lodash_1.map)(data, function (record, i) {
            var desc = (0, record_1.getRecordAbstract)(record, {
                maxLength: 128,
                includeContent: true
            });
            var media = record.media;
            var url = urlTemplate
                .replace(/\[PH.SLUG\]/g, record.slug)
                .replace(/\[PH.ID\]/g, record.id);
            return (react_1.default.createElement(SwiperSlide, { key: i },
                react_1.default.createElement("div", { className: "w-full h-full mb-16" },
                    react_1.default.createElement("div", { onClick: function () {
                            router.push(url);
                        }, className: "flex flex-col cursor-pointer mb-5 ".concat(itemTitleClassName) },
                        (0, core_1.isNonEmptyString)(media) && (react_1.default.createElement("div", { className: "w-full bg-center bg-cover mb-6", style: {
                                backgroundImage: "url(".concat(media, ")"),
                                height: 0,
                                paddingTop: "66%"
                            } })),
                        react_1.default.createElement("div", { className: "font-semibold text-lg ".concat((0, core_1.isNonEmptyString)(desc)
                                ? "mb-3"
                                : "mb-0") }, (0, primeobjects_helper_util_1.getRecordDisplay)(record)),
                        react_1.default.createElement("div", { className: "text-gray-500" }, desc)))));
        })))))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
exports.SiteSwiperSection = SiteSwiperSection;
exports.default = exports.SiteSwiperSection;
//# sourceMappingURL=site-swiper.js.map