//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import { getDefaultFirstBodyCell, DEFAULT_LIST_EDIT_COLUMN, DEFAULT_LIST_ACTION_COLUMN, DEFAULT_LIST_PLAY_COLUMN } from "../../sections/list/util";
import { doNothing } from "primeobjects-helper-util";
export var getAIExtractorColumnsForCustomization = function (onClickRecord, entity, settings) {
    var currentSettings = settings ? settings : {};
    var recordInAction = currentSettings.recordInAction, context = currentSettings.context;
    return [
        getDefaultFirstBodyCell(onClickRecord, entity, settings),
        DEFAULT_LIST_EDIT_COLUMN(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        }),
        DEFAULT_LIST_ACTION_COLUMN(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        })
    ];
};
export var getAIExtractorColumnsForUser = function (onClickRecord, entity, settings) {
    var currentSettings = settings ? settings : {};
    var recordInAction = currentSettings.recordInAction, context = currentSettings.context;
    return [
        getDefaultFirstBodyCell(onClickRecord, entity, settings),
        DEFAULT_LIST_PLAY_COLUMN(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        })
    ];
};
export var getAIExtractorListForCustomization = function (list, context) {
    doNothing({ list: list, context: context });
    return {
        sectionProps: {
            query: { service: "hidden" },
            getColumns: getAIExtractorColumnsForCustomization
        }
    };
};
export var getAIExtractorListForUser = function (list, context) {
    doNothing({ list: list, context: context });
    return {
        sectionProps: {
            query: { service: "hidden", scope: "published" },
            getColumns: getAIExtractorColumnsForUser
        }
    };
};
//# sourceMappingURL=ai-extractor.js.map