//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect } from "react";
import Head from "./head";
import PageLoader from "./loader";
import PageError from "./error";
import { checkPageError } from "./util";
import { useCurrentContext } from "../context/use-current-context";
import { setSolution } from "primeobjects-helper-ui/build/cjs/hooks/solution";
import { isEmpty } from "lodash";
import { setAppTrack, setLibTrack, isSSR } from "primeobjects-helper-util/build/cjs/core";
export var AppBasePage = function (props) {
    var _a, _b, _c;
    var solution = props.solution, onContextReady = props.onContextReady, appTrack = props.appTrack, libTrack = props.libTrack, allowGuest = props.allowGuest;
    var children = props.children, headProps = props.headProps;
    var currentContextSettings = props.currentContextSettings
        ? props.currentContextSettings
        : {
            signInUrl: "/auth/sign-in"
        };
    var context = useCurrentContext(solution, __assign(__assign({}, currentContextSettings), { signInUrl: !allowGuest ? currentContextSettings.signInUrl : "", componentName: "/page/app-base.tsx" }));
    var pageError = checkPageError(props);
    useEffect(function () {
        setSolution(solution);
        if (!isEmpty(context) || allowGuest) {
            onContextReady(context);
        }
        setAppTrack(appTrack == true);
        setLibTrack(libTrack == true);
    }, [context]);
    return !pageError ? (React.createElement(React.Fragment, null,
        React.createElement(Head, __assign({}, headProps)),
        !isSSR() && (((_a = context.user) === null || _a === void 0 ? void 0 : _a.id) || allowGuest) ? (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "h-screen w-full overflow-hidden flex flex-row 2xl:max-w-8xl 2xl:mx-auto ".concat((_b = props.wrapperClassname) !== null && _b !== void 0 ? _b : ""), style: (_c = props.wrapperStyle) !== null && _c !== void 0 ? _c : {} }, children))) : (React.createElement(PageLoader, { solution: solution })))) : (React.createElement(PageError, { reason: pageError }));
};
export default AppBasePage;
//# sourceMappingURL=app-base.js.map