//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import Img from "primeobjects-ui-web-basic/build/cjs/controls/img";
import SiteSection from "./site-section";
import { isNonEmptyString } from "primeobjects-helper-util";
import SiteIntroSection from "./site-intro";
import { usePrimaryColorName } from "primeobjects-helper-ui";
export var SiteMainSection = function (props) {
    var introductionProps = props.introductionProps, imageUrl = props.imageUrl, style = props.style, solution = props.solution;
    var colorName = usePrimaryColorName();
    if (!isNonEmptyString(introductionProps.colorName))
        introductionProps.colorName = colorName;
    var className = isNonEmptyString(props.className) ? props.className : "";
    return (React.createElement(SiteSection, { className: "relative ".concat(className), style: style },
        React.createElement("div", { className: "max-w-7xl mx-auto" },
            React.createElement("div", { className: "relative z-10 pb-8 bg-white sm:pb-16 md:pb-20 lg:max-w-2xl lg:w-full lg:pb-28 xl:pb-32" },
                React.createElement("div", { className: "flex flex-col mx-auto max-w-7xl pt-20" },
                    React.createElement(SiteIntroSection, __assign({}, introductionProps, { colorName: colorName, solution: solution }))))),
        React.createElement("div", { className: "lg:absolute top-0 lg:inset-y-0 lg:right-0 lg:w-1/2" },
            React.createElement(Img, { className: "h-56 w-full object-cover sm:h-72 md:h-96 lg:w-full lg:h-full transition-all duration-1000 ease-in-out opacity-100", src: imageUrl, alt: "" }))));
};
export default SiteMainSection;
//# sourceMappingURL=site-main.js.map